////Code Modified from Patience Script

// don't want this executing when building graphs
if (!$OFFLINE_NAV_BUILD)
	activatePackage(Camelot);

//Script for Camelot
//==============================================================================


//==========================BEGIN PACKAGE CAMELOT===============================
package Camelot {


// do this before the mission begins
function SiegeGame::missionLoadDone(%game)
{
	Parent::missionLoadDone(%game);
	echo(".....Running Camelot script!");

	$Vehicleoldmax[ScoutVehicle] = $Vehiclemax[ScoutVehicle];
	$Vehicleoldmax[AssaultVehicle] = $VehicleMax[AssaultVehicle];
	$Vehicleoldmax[MobileBaseVehicle] = $VehicleMax[MobileBaseVehicle];
	$Vehicleoldmax[ScoutFlyer] = $VehicleMax[ScoutFlyer];
	$Vehicleoldmax[BomberFlyer] = $VehicleMax[BomberFlyer];

	$Vehiclemax[ScoutVehicle]     = 5;
	$VehicleMax[AssaultVehicle]   = 4;
	$VehicleMax[MobileBaseVehicle]= 2;
	$VehicleMax[ScoutFlyer]       = 5;
	$VehicleMax[BomberFlyer]      = 2;
}

   //For vehicle friendly forcefields
   function ForceFieldBareData::onAdd(%data, %obj)
   {
      %obj.originalscale = %obj.getscale();
      Parent::onAdd(%data, %obj);
   }

   function ForceFieldBareData::losePower(%data, %obj)
   {
      Parent::losePower(%data, %obj);
      %obj.setscale("0 0 0");
   }
   
   function ForceFieldBareData::gainPower(%data, %obj)
   {
      %obj.setscale(%obj.originalscale);
      Parent::gainPower(%data, %obj);
   }

   //For proper drawbridge operation
   function Generator::onDisabled(%data, %obj, %prevState)
   {
      if (%obj == game.DrawbridgeGen)
         game.GenDown = 1;
      Parent::onDisabled(%data, %obj, %prevState);
   }

   function Generator::onEnabled(%data, %obj, %prevState)
   {
      if (%obj == game.DrawbridgeGen)
         game.GenDown = 0;
      Parent::onEnabled(%data, %obj, %prevState);
   }  

   //To clean everything up
   function SiegeGame::gameOver(%game)
   {
      cancel(game.Camsch);
      Parent::gameOver(%game);

      $Vehiclemax[ScoutVehicle] = $Vehicleoldmax[ScoutVehicle];
      $Vehiclemax[AssaultVehicle] = $VehicleoldMax[AssaultVehicle];
      $Vehiclemax[MobileBaseVehicle] = $VehicleoldMax[MobileBaseVehicle];
      $Vehiclemax[ScoutFlyer] = $VehicleoldMax[ScoutFlyer];
      $Vehiclemax[BomberFlyer] = $VehicleoldMax[BomberFlyer];

      deactivatePackage(Camelot);
      deleteVariables("$Vehicleoldmax*");
   }

function Bridgerotate(%objct){

         if(!isObject(%objct))
            return;

         %rotatecoords = getWords(%objct.rotation, 0, 2);
         %rotatedeg = getWord(%objct.rotation, 3);

         if( game.GenDown == 1 && %rotatedeg > 0){
             %rotatedeg = %rotatedeg - 2;
             %objct.rotation = %rotatecoords @ " " @ %rotatedeg;
             %objct.setTransform(%objct.getTransform());
         }
         if( game.GenDown == 0 && %rotatedeg < 90){
             %rotatedeg = %rotatedeg + 2;
             %objct.rotation = %rotatecoords @ " " @ %rotatedeg;
             %objct.setTransform(%objct.getTransform());
         }
         %objct.Locked = true;
         game.Camsch = Schedule(250, game, Bridgerotate, %objct);
}

function Lowerobject(%objct){

         if (!isObject(%objct))
            return;

         %pos = getWords(%objct.position, 0, 1);
         %zvalue = getWord(%objct.position, 2);

         if( game.GenDown == 1 && %zvalue > 74){
             %zvalue = %zvalue - 0.5;
             %objct.position = %pos @ " " @ %zvalue;
             %objct.setTransform(%objct.getTransform());
         }
         if( game.GenDown == 0 && %zvalue < 98){
             %zvalue = %zvalue + 0.5;
             %objct.position = %pos @ " " @ %zvalue;
             %objct.setTransform(%objct.getTransform());
         }
         %objct.Locked = true;
         game.Camsch = Schedule(250,game, Lowerobject, %objct);
}


};
//End Camelot Package
